diff -urpN john-1.7.8-jumbo-6a/src/pkzip_fmt_plug.c john-1.7.8-jumbo-6b/src/pkzip_fmt_plug.c
--- john-1.7.8-jumbo-6a/src/pkzip_fmt_plug.c	2011-09-01 15:26:20.968750000 +0000
+++ john-1.7.8-jumbo-6b/src/pkzip_fmt_plug.c	2011-09-09 20:44:27.000000000 +0000
@@ -20,9 +20,11 @@
 #include "arch.h"
 #include "misc.h"
 #include "formats.h"
+//#define USE_PKZIP_MAGIC 1
 #include "pkzip.h"
 
 #include "zlib.h"
+#include "pkzip_inffixed.h"  // This file is a data file, taken from zlib
 
 #ifdef _OPENMP
 #include <omp.h>
@@ -33,7 +35,7 @@
 #define ALGORITHM_NAME			"N/A"
 
 #define BENCHMARK_COMMENT		""
-#define BENCHMARK_LENGTH		0
+#define BENCHMARK_LENGTH		-1001
 
 #define PLAINTEXT_LENGTH		31
 
@@ -49,7 +51,8 @@
 #define MAX_KEYS_PER_CRYPT		64
 #endif
 
-//#define ZIP_DEBUG
+//#define ZIP_DEBUG 1
+//#define ZIP_DEBUG 2
 
 /*
  * It is likely that this should be put into the arch.h files for the different systems,
@@ -59,79 +62,70 @@
  */
 #define PKZIP_USE_MULT_TABLE
 
+#if ARCH_LITTLE_ENDIAN
+#define KB1 0
+#define KB2 3
+#else
+#define KB1 3
+#define KB2 0
+#endif
+
 /*
- *  format:
- *    $pkzip1$					version 1 of pkzip hashes.
- *    Number of test records*
- *    bytes_of_checksum_valid*	Either 1 or 2 byte validation.  PKZIP > 2 will only use 1.
- *                               Older stuff (and many unixes), validate against both bytes.
- *                               These both byte validations cuts down a lot on items needing
- *                               to be validated.
+ *  format:  filename:$pkzip$C*B*[DT*MT{CL*UL*CR*OF*OX}*CT*DL*DA]*$/pkzip$
  *
- *    Flags (which fields are present, after the checksum hashes).
- *      1 chksum_tst_only  (only does a checksum test, not the decompress test)
- *      2 ASCII.     Field ascii length, and ascii 'hash' will be filled in.
- *      4 CRC_LEN    Fields CRC32, comp_len and decomp_len filled in.
- *      8 FileName   Fields Offset and FileName are filled in
- *      16 FileData  The .zip compressed/encrypted data will be provided.
+ * All numeric and 'binary data' fields are stored in hex.
+ *
+ * C   is the count of hashes present (the array of items, inside the []  C can be 1 to 3.).
+ * B   is number of valid bytes in the checksum (1 or 2).  Unix zip is 2 bytes, all others are 1
+ * ARRAY of data starts here (there will be C array elements)
+ *   DT  is a "Data Type enum".  This will be 1 2 or 3.  1 is 'partial'. 2 and 3 are full file data (2 is inline, 3 is load from file).
+ *   MT  Magic Type enum.  0 is no 'type'.  255 is 'text'. Other types (like MS Doc, GIF, etc), see source.
+ *     NOTE, CL, DL, CRC, OFF are only present if DT != 1
+ *     CL  Compressed length of file blob data (includes 12 byte IV).
+ *     UL  Uncompressed length of the file.
+ *     CR  CRC32 of the 'final' file.
+ *     OF  Offset to the PK\x3\x4 record for this file data. If DT==2, then this will be a 0, as it is not needed, all of the data is already included in the line.
+ *     OX  Additional offset (past OF), to get to the zip data within the file.
+ *     END OF 'optional' fields.
+ *   CT  Compression type  (0 or 8)  0 is stored, 8 is imploded.
+ *   DL  Length of the DA data.
+ *   DA  This is the 'data'.  It will be hex data if DT==1 or 2. If DT==3, then it is a filename (name of the .zip file).
+ * END of array items.
+ * The format string will end with $/pkzip$
+ *
+ * NOTE, after some code testing, it has come to show, that the 'magic' may not be needed, or very useful. The problem with it, is IF the file
+ * ends up NOT starting with any of the magic values, then we will have a false negative, and NEVER be able to crack the zip's password. For now
+ * we have a #define (right before the #include "pkzip.h").  If that define is uncommented, then pkzip format will be built with magic logic. 
+ * However, right now it is not being built that way.
  *
- *     12_byte_hash_plus_2_byte_chksum_inhex*    This is the 12 byte hash of the file,
- *                                               and the 2 bytes of crc.
- *     [12_byte_hash2*[hash3*[hash4*[hash5*]]]]  (up to 5 files from a zip file can be here.
- *                                               More files means a 'correct' checksum is
- *                                               likely to be the right one.
- *     ASCII hash len*   if flags&2
- *     asciiCompType*    if flags&2
- *     ASCII hash data*  if flags&2
- *     CRC32*            if flags&4
- *     Compr_len*        if flags&4
- *     deCompr_len*      if flags&4
- *     compType*         if flags&4       The compression type of the 'whole' blob. 0 or 8
- *     Offset*           Only if flags&8  this is the offset from start of file to the
- *                                        compressed/encrypted deflated 'blob' of data.
- *     FileName*         if flags&8       the name of the .zip file.  NOTE, that file WILL be
- *                                        required.  Filename cant contain a '*' charcter.
- *     InternalFName*    if flags*8       This is the name of the file.  Used if we implement
- *                                        a spawn to unzip -P to test passwords.
- *     FileData*         if flags&16      This IS the .zip data (the compressed/encrypted blob.
- *                                        If the file is small (or a small one 'exists' in the
- *                                        .zip, then the data can be put here inline.
  */
 static struct fmt_tests tests[] = {
-	/* a few 'simple' checksum only hashes */
-	{"$pkzip1$1*2*1*c97839b8fe9e0373ba3c7b29ac6f************", "love"},
-	{"$pkzip1$1*1*1*4f83334e87f67a42fce2a53ef967************", "john"},
-	{"$pkzip1$1*1*1*fcf7385e0c4466cd621743a7f967************", "john"},
-	/* 4 hashes in the next one. */
-	{"$pkzip1$4*2*1*dce4fb16f19b70cf9c368a5c139b*e27bc3e3adb1cc0f227758f38b8d*20f4ad0590ec2b44ff8510266aec*f63277b2a5ea02bcaed067ee71a6************", "john"},
-	/* 8 hashes (max) made with info-zip (2 byte checksums, NOTE they are all the same, since the files were created close to each other) */
-	{"$pkzip1$8*2*1*a4a8ac4a5dc8e54105390fb0742d*828c2ccc5be1dbd632aefa1c742d*7a89efd471da46d59570a465742d*47a2799835a2adffd7dbb4ef742d*f71e5644a2efb450173602d6742d*\
-b09fa98d83f0bb3a06a8bed0742d*1a042b99ad076f9a41e250f8742d*26222d5d8d26f6506c8c9fec742d************", "P^$sW0R9"},
-	/* 8 hashes (max) made by pkzip, so only 1 byte 'valid' */
-	{"$pkzip1$8*1*1*c18675da635e8c05bd4a1b76e162*4be88995ea780d02014c37cdf651*40a798f2dd1482860aea6e70e539*b146f66e800914fcfdd9f17e635c*05570fc392bf9e40080425c9901f*\
-234302627ca721b2acf8d97bcde1*057b6feb54ad24fa8e028e821233*89fc3126769848e44102d741a8c1************", "P^$sW0R9"},
-	{"$pkzip1$1*2*1*20f4ad0590ec2b44ff8510266aec************", "john"},
-	/* 1 hash, an ASCII check (step 2), and a 'full' inline test blob (test 3) */
-	{"$pkzip1$1*2*16*20f4ad0590ec2b44ff8510266aec*38*8*20f4ad0590ec2b44ff85102650314ec911cc2227bdb0e5ced23ea8517ce4bdc5ec77136e450641fcfe317fd36e069de280f6623e34085186*f967d462*\
-54*49*8****20F4AD0590EC2B44FF85102650314EC911CC2227BDB0E5CED23EA8517CE4BDC5EC77136E450641FCFE317FD36E069DE280F6623E34085186F3A4FEE45EB6D4C6AABF9B7A5A142D456CF542C1EB35BCAAE120330D*", "john"},
-    /* 1 hash, and an ASCII check (step 2) */
-	{"$pkzip1$1*2*2*20f4ad0590ec2b44ff8510266aec*38*8*20f4ad0590ec2b44ff85102650314ec911cc2227bdb0e5ced23ea8517ce4bdc5ec77136e450641fcfe317fd36e069de280f6623e34085186*********", "john"},
-	/* 1 hash, and a 'full' inline test blob (test 3) */
-	{"$pkzip1$5*1*14*556f978a58fa4d1bbd18c6ad7cf3*15d082fd66f783745e02a9a4e138*515d1afdf3036ceddd74f6c2e6a0*117e84fce498fc1aa4ba251efed7*55f7bd45d53f0345aac7a408ac0f*\
-***fed7246b*4c6*e00*8****117e84fce498fc1aa4ba251e5eae6d70747ce420626b1306568499b7600bc9758b0cb03b3eec5343b745b24a41f26b95794af638ff195878692a7bb012d6457bc36b6b48a4f01e99b5c7febaeee\
-a045abd0286f8fe676bbf28c6232555b71f242794cb3bf9df89eab681e8436c7fdc561c951d2ffbf6e3ac5302cbad5706c5f59f8f1806e76b465f1f4280e829db18c0ddc3b181b6fa992076b6f1641539b5f45142004db41d5ed\
-158338f663822612bd8ad18676dc7d40148bb006e4d4033f9dfe80526862286afb908d2f46b895cdc11e15fd2712932ba491a82aeadc231612c6cbc304858d80a46378f72dcda91ea70adfeda96c0fbdd17a954dd4f88fb6c44b\
-d362e0302fe209ac1b9a06a1b7f35dc6208b58d5315058322c85117184e279f4aaec3870a8f05dc2aff0e8bc8613adbc30a95f77f9594132027f44217164c193ab2568a7c175bc41bb6ba96e847746e40d179cc41da890049d35\
-7488645ff4ec952254f47c5d48edb59e1f46a406ae7c2002c88706168dcd24dd4829e9ea454e67ebe2633d162f0d50c41a3a78e6582ce132cf580dc507be23b4e58c9ef2f45d61b909ba68dc1b765e97699207d76e4f488b45be\
-a674feaa56f05bfbb9e103aef0790df9d57097803842aa9c975d4ddaaf68c770a54f815e64b518972feba8381f7d4ab36a3fef1098d75bad8d8bb87f2316e8f20e18e26955120b5c563b6017dd3d7e9ad00e38f60a00f516455f\
-70b9ce84cb46104de15130ecdb28d836197b35b0c2ac87f60ee5eda4dd1a0873ca9932027b1cccada6a00f2d3de6f682f0b74e8baccd40ffc3fc9765a6dd3f4f06e3ad33bb4f82f200d65040fa13ed4abc0204e97fc84bc819bb\
-95e20c8d58bff5b269c26a99094fa3333f857b36bfa1de58d99fcaee4f0261272d780d7416eae9606984599c65b29e5e83cfedbf5b6a3fc6047294770fded9f64dfbe05a933840a2a27aa7c5b13b6a5de598de67f7c8d531ccbd\
-9089c2aa081d95166f88650acf3804097ef5b65d3883397cdea39b33f5e490ed4677884c15270dce76970be24d8efcbdd7880dd9ef849aabfb5359cdcdbcd68dbe985b53caed3442ef0e2fe584bab26c84f5f3e26a6d15d6ceba\
-e5610c81da50ced1bd4d24e4761a9a33a48dd818af569ed9370d1a68436a1e285c454830af0a34402d810cf95044c24cc0b6f8602afc97229662a2ecc7791d4b9adbe763f4e873d98a8c71f7d378aa07e55d922500857c633885\
-501ef3444c1a169d07f16c72896f299472d21d09258ee8a82b2b8bb224557ca8f2fc0dcb5dd2a7548cc65937d8c160dc6e26dd0cbbc011c6bf85f60d944364052e1e7369eaa2c32f7203e8efc4b4bb4744d6d8f5272335377222\
-9f51dba75b8f695f824f0d23c69e257200d61091a55213b23dc3902960f27b66995a06c7796f87d9abe4aa1a94f7907d97d20f2591d8f370940d7419d732fdb13a93989467e5773c9ae3320c8ae9cfe0ce3b482bffd35be7df11\
-e3a33789cd383c4b56fa26aab823228e163c0981e73426dd3f5d0e2c887de924e7abdfe5818f98fde9afb359fe13925161cb017c0ac5be55a7294958e8792a0172bcdeb2605402ccf1299011e86861e85204b8c46afceea53502\
-d0cf4f6b2c23618eb41064842441345b3792abd1a258da71e54b3bddc542b566137e718d59ed219c6331d2846ed6fdeafe1d6f572fd87f28c1cd45f3d7122e0ae*", "password"},
+
+	/* compression of a perl file. We have the same password, same file used twice in a row (pkzip, 1 byte checksum).  NOTE, pkzip uses random IV, so both encrypted blobs are different */
+	{"\
+$pkzip$1*1*2*0*e4*1c5*eda7a8de*0*4c*8*e4*eda7*194883130e4c7419bd735c53dec36f0c4b6de6daefea0f507d67ff7256a49b5ea93ccfd9b12f2ee99053ee0b1c9e1c2b88aeaeb6bd4e60094a1ea118785d4ded6dae94\
+cade41199330f4f11b37cba7cda5d69529bdfa43e2700ba517bd2f7ff4a0d4b3d7f2559690ec044deb818c44844d6dd50adbebf02cec663ae8ebb0dde05d2abc31eaf6de36a2fc19fda65dd6a7e449f669d1f8c75e9daa0a3f7b\
+e8feaa43bf84762d6dbcc9424285a93cedfa3a75dadc11e969065f94fe3991bc23c9b09eaa5318aa29fa02e83b6bee26cafec0a5e189242ac9e562c7a5ed673f599cefcd398617*$/pkzip$", "password" },
+	{"\
+$pkzip$1*1*2*0*e4*1c5*eda7a8de*0*4c*8*e4*eda7*581f798527109cbadfca0b3318435a000be84366caf9723f841a2b13e27c2ed8cdb5628705a98c3fbbfb34552ed498c51a172641bf231f9948bca304a6be2138ab718f\
+6a5b1c513a2fb80c49030ff1a404f7bd04dd47c684317adea4107e5d70ce13edc356c60bebd532418e0855428f9dd582265956e39a0b446a10fd8b7ffb2b4af559351bbd549407381c0d2acc270f3bcaffb275cbe2f628cb09e2\
+978e87cd023d4ccb50caaa92b6c952ba779980d65f59f664dde2451cc456d435188be59301a5df1b1b4fed6b7509196334556c44208a9d7e2d9e237f591d6c9fc467b408bf0aaa*$/pkzip$", "password" },
+	/* Now the same file, compressed twice, using unix zip (info-zip), with 2 byte checksums */
+	{"\
+$pkzip$1*2*2*0*e4*1c5*eda7a8de*0*47*8*e4*4bb6*436c9ffa4328870f6272349b591095e1b1126420c3041744650282bc4f575d0d4a5fc5fb34724e6a1cde742192387b9ed749ab5c72cd6bb0206f102e9216538f095fb7\
+73661cfde82c2e2a619332998124648bf4cd0da56279f0c297567d9b5d684125ee92920dd513fd18c27afba2a9633614f75d8f8b9a14095e3fafe8165330871287222e6681dd9c0f830cf5d464457b257d0900eed29107fad8af\
+3ac4f87cf5af5183ff0516ccd9aeac1186006c8d11b18742dfb526aadbf2906772fbfe8fb18798967fd397a724d59f6fcd4c32736550986d227a6b447ef70585c049a1a4d7bf25*$/pkzip$", "password" },
+	{"\
+$pkzip$1*2*2*0*e4*1c5*eda7a8de*0*47*8*e4*4bb6*436c9ffa4328870f6272349b591095e1b1126420c3041744650282bc4f575d0d4a5fc5fb34724e6a1cde742192387b9ed749ab5c72cd6bb0206f102e9216538f095fb7\
+73661cfde82c2e2a619332998124648bf4cd0da56279f0c297567d9b5d684125ee92920dd513fd18c27afba2a9633614f75d8f8b9a14095e3fafe8165330871287222e6681dd9c0f830cf5d464457b257d0900eed29107fad8af\
+3ac4f87cf5af5183ff0516ccd9aeac1186006c8d11b18742dfb526aadbf2906772fbfe8fb18798967fd397a724d59f6fcd4c32736550986d227a6b447ef70585c049a1a4d7bf25*$/pkzip$", "password"},
+	/* now a pkzip archive, with 3 files, 1 byte checksum */
+	{"\
+$pkzip$3*1*1*0*8*24*4001*8986ec4d693e86c1a42c1bd2e6a994cb0b98507a6ec937fe0a41681c02fe52c61e3cc046*1*0*8*24*4003*a087adcda58de2e14e73db0043a4ff0ed3acc6a9aee3985d7cb81d5ddb32b840ea20\
+57d9*2*0*e4*1c5*eda7a8de*0*4c*8*e4*eda7*89a792af804bf38e31fdccc8919a75ab6eb75d1fd6e7ecefa3c5b9c78c3d50d656f42e582af95882a38168a8493b2de5031bb8b39797463cb4769a955a2ba72abe48ee75b103\
+f93ef9984ae740559b9bd84cf848d693d86acabd84749853675fb1a79edd747867ef52f4ee82435af332d43f0d0bb056c49384d740523fa75b86a6d29a138da90a8de31dbfa89f2f6b0550c2b47c43d907395904453ddf42a665\
+b5f7662de170986f89d46d944b519e1db9d13d4254a6b0a5ac02b3cfdd468d7a4965e4af05699a920e6f3ddcedb57d956a6b2754835b14e174070ba6aec4882d581c9f30*$/pkzip$", "3!files"},
+
 	{NULL}
 };
 
@@ -144,16 +138,18 @@ static u32  K12[MAX_KEYS_PER_CRYPT*3];
 static PKZ_SALT *salt;
 static u8 chk[MAX_KEYS_PER_CRYPT];
 static int dirty=1;
+#if USE_PKZIP_MAGIC
+static ZIP_SIGS SIGS[256];
+#endif
 #ifdef PKZIP_USE_MULT_TABLE
 static u8 mult_tab[16384];
+#define PKZ_MULT(b,w) b^mult_tab[(u16)(w.u)>>2]
+#else
+inline u8 PKZ_MULT(u8 b, MY_WORD w) {u16 t = w.u|2; return b ^ (u8)(((u16)(t*(t^1))>>8)); }
 #endif
 
-/* This field is used in cmp_exact loop.  It is a buffer where we decompress     */
-/* a block at a time, while also performing CRC checking                         */
-static u8 ucpr_buf[UBUF_SIZE];
-
 extern struct fmt_main fmt_pkzip;
-static const char *ValidateZipContents(FILE *in, long offset, int len, u32 crc, const char *sIntName);
+static const char *ValidateZipContents(FILE *in, long offset, u32 offex, int len, u32 crc);
 
 /* Similar to strtok, but written specifically for the format. */
 static u8 *GetFld(u8 *p, u8 **pRet) {
@@ -186,6 +182,16 @@ static int is_hex_str(const u8 *cp) {
 	return 1;
 }
 
+unsigned get_hex_num(const u8 *cp) {
+	char b[3];
+	unsigned u;
+	b[0] = (c8)cp[0];
+	b[1] = (c8)cp[1];
+	b[2] = 0;
+	sscanf(b, "%x", &u);
+	return u;
+}
+
 /* Since the pkzip format textual representation is pretty complex, with multiple   */
 /* 'optional' sections, we have a VERY complete valid.  Valid will make SURE that   */
 /* the format is completely valid. Thus, there is little or no error checking later */
@@ -199,19 +205,20 @@ static int is_hex_str(const u8 *cp) {
 static int valid(char *ciphertext, struct fmt_main *pFmt)
 {
 	u8 *p, *cp;
-	int cnt, len;
-	u32 flags, crc;
+	int cnt, len, data_len;
+	u32 crc;
 	FILE *in;
 	const char *sFailStr;
-	char *sName, *sIntName;
 	long offset;
+	u32 offex;
+	int type;
 
-	if (strncmp(ciphertext, "$pkzip1$", 7))
+	if (strncmp(ciphertext, "$pkzip$", 6))
 		return 0;
 
 	cp = (u8*)str_alloc_copy(ciphertext);
 
-	p = &cp[8];
+	p = &cp[7];
 	p = GetFld(p, &cp);
 	if (!p || *p==0) {
 		sFailStr = "Out of data, reading count of hashes field"; goto Bail; }
@@ -221,85 +228,70 @@ static int valid(char *ciphertext, struc
 	p = GetFld(p, &cp);
 	if (!p || *p==0 || *cp < '1' || *cp > '2') {
 		sFailStr = "Number of valid hash bytes empty or out of range"; goto Bail; }
-	p = GetFld(p, &cp);
-	if (!p || *p==0 || cp[0] == 0 || !is_hex_str(cp)) {
-		sFailStr = "Flags field empty, or not a hex string"; goto Bail; }
-	sscanf((c8*)cp, "%x", &flags);
 
 	while (cnt--) {
 		p = GetFld(p, &cp);
-		if ( !p || *p==0 || strlen((c8*)cp) != 28 || !is_hex_str(cp)) {
-			sFailStr = "Invalid hash found (missing or not 28 bytes of hex)"; goto Bail; }
-	}
-
-	/* Handle flags&2 */
-	p = GetFld(p, &cp);
-	if ( !p || *p==0 || ((flags&2) && (!strlen((c8*)cp) || !is_hex_str(cp)))) {
-			sFailStr = "Length of ASCII blob missing (with flags&2 set)"; goto Bail; }
-	sscanf((c8*)cp, "%x", &len);
-	p = GetFld(p, &cp);
-	if ( !p || *p==0 || ((flags&2) && !(*cp=='0'||*cp=='8'))) {
-			sFailStr = "Invalid compression type for ASCII blob (with flags&2 set)"; goto Bail; }
-	p = GetFld(p, &cp);
-	if ( !p || *p==0 || ((flags&2) && (strlen((c8*)cp) != (len<<1) || !is_hex_str(cp)))) {
-			sFailStr = "ASCII blob missing, wrong legth or not hex (with flags&2 set)"; goto Bail; }
-
-	/* Handle flags&4 */
-	p = GetFld(p, &cp);
-	if ( !p || *p==0 || ((flags&4) && (!strlen((c8*)cp) || !is_hex_str(cp)))) {
-			sFailStr = "Crc data missing or not hex, (with flags&4 set)"; goto Bail; }
-	sscanf((c8*)cp, "%x", &crc);
-	p = GetFld(p, &cp);
-	if ( !p || *p==0 || ((flags&4) && (!strlen((c8*)cp) || !is_hex_str(cp)))) {
-			sFailStr = "Compressed Length data missing or not hex, (with flags&4 set)"; goto Bail; }
-	sscanf((c8*)cp, "%x", &len);
-	p = GetFld(p, &cp);
-	if ( !p || *p==0 || ((flags&4) && (!strlen((c8*)cp) || !is_hex_str(cp)))) {
-			sFailStr = "deCompressed Length data missing or not hex, (with flags&4 set)"; goto Bail; }
-	p = GetFld(p, &cp);
-	if ( !p || *p==0 || ((flags&4) && !(*cp=='0'||*cp=='8'))) {
-			sFailStr = "Invalid compression type for main FULL blob (with flags&4 set)"; goto Bail; }
-
-	/* Handle flags&8 */
-	p = GetFld(p, &cp);
-	if ( !p || *p==0 || ((flags&8) && (!strlen((c8*)cp) || !is_hex_str(cp)))) {
-			sFailStr = "File Offset data missing or not hex, (with flags&8 set)"; goto Bail; }
-	sscanf((c8*)cp, "%lx", &offset);
-	p = GetFld(p, &cp);
-	if ( !p || *p==0 || ((flags&8) && !strlen((c8*)cp))) {
-			sFailStr = "Zip-FileName data missing or not hex, (with flags&8 set)"; goto Bail; }
-	sName = (c8*)cp;
-	p = GetFld(p, &cp);
-	if ( !p || *p==0 || ((flags&8) && !strlen((c8*)cp))) {
-			sFailStr = "Internal FileName data missing or not hex, (with flags&8 set)"; goto Bail; }
-	sIntName = (c8*)cp;
-
-	if (flags&8) {
-		in = fopen(sName, "rb"); /* have to open in bin mode for OS's where this matters, DOS/Win32 */
-		if (!in) {
-			/* this error is listed, even if not in pkzip debugging mode. */
-			fprintf(stderr, "Error loading a pkzip hash line. The ZIP file '%s' could NOT be found\n", cp);
-			return 0;
+		if ( !p || *cp<'1' || *cp>'3') {
+			sFailStr = "Invalid data enumeration type"; goto Bail; }
+		type = *cp - '0';
+		p = GetFld(p, &cp);
+		if ( !p || !is_hex_str(cp)) {
+			sFailStr = "Invalid type enumeration"; goto Bail; }
+		if (type > 1) {
+			p = GetFld(p, &cp);
+			if ( !p || !cp[0] || !is_hex_str(cp)) {
+				sFailStr = "Invalid compressed length"; goto Bail; }
+			sscanf((c8*)cp, "%x", &len);
+			p = GetFld(p, &cp);
+			if ( !p || !cp[0] || !is_hex_str(cp)) {
+				sFailStr = "Invalid data length value"; goto Bail; }
+			p = GetFld(p, &cp);
+			if ( !p || !cp[0] || !is_hex_str(cp)) {
+				sFailStr = "Invalid CRC value"; goto Bail; }
+			sscanf((c8*)cp, "%x", &crc);
+			p = GetFld(p, &cp);
+			if ( !p || !cp[0] || !is_hex_str(cp)) {
+				sFailStr = "Invalid offset length"; goto Bail; }
+			sscanf((c8*)cp, "%lx", &offset);
+			p = GetFld(p, &cp);
+			if ( !p || !cp[0] || !is_hex_str(cp)) {
+				sFailStr = "Invalid offset length"; goto Bail; }
+			sscanf((c8*)cp, "%x", &offex);
 		}
-		sFailStr = ValidateZipContents(in, offset, len, crc, sIntName);
-		fclose(in);
-		if (*sFailStr) {
-			/* this error is listed, even if not in pkzip debugging mode. */
-			fprintf(stderr, "pkzip validation failed [%s] Hash is %s\n", sFailStr, ciphertext);
-			return 0;
+		p = GetFld(p, &cp);
+		if ( !p || (*cp != '0' && *cp != '8')) {
+			sFailStr = "Compression type enumeration"; goto Bail; }
+		p = GetFld(p, &cp);
+		if ( !p || !is_hex_str(cp)) {
+			sFailStr = "data length value"; goto Bail; }
+		sscanf((c8*)cp, "%x", &data_len);
+		p = GetFld(p, &cp);
+		if ( !p || !is_hex_str(cp) || strlen((c8*)cp) != 4) {
+			sFailStr = "invalid checksum value"; goto Bail; }
+		p = GetFld(p, &cp);
+		if (type == 3) {
+			if ( !p || strlen((c8*)cp) != data_len) {
+				sFailStr = "invalid checksum value"; goto Bail; }
+			in = fopen((c8*)cp, "rb"); /* have to open in bin mode for OS's where this matters, DOS/Win32 */
+			if (!in) {
+				/* this error is listed, even if not in pkzip debugging mode. */
+				fprintf(stderr, "Error loading a pkzip hash line. The ZIP file '%s' could NOT be found\n", cp);
+				return 0;
+			}
+			sFailStr = ValidateZipContents(in, offset, offex, len, crc);
+			fclose(in);
+			if (*sFailStr) {
+				/* this error is listed, even if not in pkzip debugging mode. */
+				fprintf(stderr, "pkzip validation failed [%s] Hash is %s\n", sFailStr, ciphertext);
+				return 0;
+			}
+		} else {
+			if ( !p || !is_hex_str(cp) || strlen((c8*)cp) != data_len<<1) {
+				sFailStr = "invalid checksum value"; goto Bail; }
 		}
 	}
-
-	/* Handle flags&16 */
 	p = GetFld(p, &cp);
-	if ( !p || *p || ((flags&16) && (strlen((c8*)cp) != (len<<1) || !is_hex_str(cp)))) {
-			sFailStr = "Compressed/Encrypted ZIP data is missing or not right size, or not hex, (with flags&16 set)"; goto Bail; }
-
-	// if we have the 'full' file (or file name), and not the CRC and complen, then bail.
-	if ( (flags & (8|16)) && !(flags&4)) {
-			sFailStr = "Flags are set wrong.  If either flags&8 or flags&16, then flags&4 must be set."; goto Bail; }
-
-	return 1;
+	return !strcmp((c8*)cp, "$/pkzip$");
 
 Bail:;
 #ifdef ZIP_DEBUG
@@ -326,57 +318,42 @@ static u16 fget16(FILE * fp)
 	return v;
 }
 
-static const char *ValidateZipContents(FILE *fp, long offset, int _len, u32 _crc, const char *_sIntName) {
-	long curoff, offmin;
+static const char *ValidateZipContents(FILE *fp, long offset, u32 offex, int _len, u32 _crc) {
 	u32 id;
+	u16 version, flags, method, modtm, moddt, namelen, exlen;
+	u32 crc, complen, uncomplen;
 
-	/* 31 is the MINIMUM offset from start of file, to start of a compressed block. (old pkzip, 1 byte filename length) */
-	if (offset < 31)
-		return "Compressed zip file offset is too small (or negative). (with flags&8 set)";
-
-	offmin = offset-4096;
-	if (offmin < 0) offmin = 0;
-	for (curoff = offset-1; curoff >= offmin; --curoff) {
-		fseek(fp, curoff, SEEK_SET);
-		id = fget32(fp);
-		if (id == 0x04034b50UL) {	/* Found the local header */
-			/* Ok, see if this IS the correct file blob. */
-			u16 version = fget16(fp);
-			u16 flags = fget16(fp);
-			u16 method = fget16(fp);
-			u16 modtm = fget16(fp);
-			u16 moddt = fget16(fp);
-			u32 crc = fget32(fp);
-			u32 complen = fget32(fp);
-			u32 uncomplen = fget32(fp);
-			u16 namelen = fget16(fp);
-			u16 exlen = fget16(fp);
-
-			/* unused vars. */
-			(void)uncomplen;
-			(void)modtm;
-			(void)moddt;
-
-			/* Even if we 'miss', we keep walking back. We 'can' miss if the CRC of file, or some other       */
-			/* binary data happens to have the 0x04034b50 signature, thus giving us a false local header hit. */
-			if (_crc == crc && _len == complen && 0x14 == version && (flags & 1) && (method == 8 || method == 0)) {
-				/* skip file name, an any 'extra' data. */
-				(void)_sIntName;
-				fseek(fp, namelen, SEEK_CUR);
-				if (exlen)
-					fseek(fp, exlen, SEEK_CUR);
-				if (ftell(fp) == offset)
-					/* This is actually the SUCCESS :) */
-					return "";
+	if (fseek(fp, offset, SEEK_SET) != 0)
+		return "Not able to seek to specified offset in the .zip file, to read the zip blob data.";
 
-				return "The offset to the internal ZIP data for this file is NOT valid";
-			}
-		}
-	}
+	id = fget32(fp);
+	if (id != 0x04034b50U)
+		return "Compressed zip file offset does not point to start of zip blob";
+
+	/* Ok, see if this IS the correct file blob. */
+	version = fget16(fp);
+	flags = fget16(fp);
+	method = fget16(fp);
+	modtm = fget16(fp);
+	moddt = fget16(fp);
+	crc = fget32(fp);
+	complen = fget32(fp);
+	uncomplen = fget32(fp);
+	namelen = fget16(fp);
+	exlen = fget16(fp);
+
+	/* unused vars. */
+	(void)uncomplen;
+	(void)modtm;
+	(void)moddt;
+
+	/* Even if we 'miss', we keep walking back. We 'can' miss if the CRC of file, or some other       */
+	/* binary data happens to have the 0x04034b50 signature, thus giving us a false local header hit. */
+	if (_crc == crc && _len == complen && 0x14 == version && (flags & 1) && (method == 8 || method == 0) && offex==30+namelen+exlen)
+		return "";
 	return "We could NOT find the internal zip data in this ZIP file";
 }
 
-
 static void init(struct fmt_main *pFmt)
 {
 	unsigned short n=0;
@@ -397,32 +374,113 @@ static void init(struct fmt_main *pFmt)
 #endif
 
 #ifdef _OPENMP
-	// This can be tuned but it's tedious.
+	/* This can be tuned but it's tedious. */
 	n = omp_get_max_threads();
 	if (n*256 < MAX_KEYS_PER_CRYPT)
 		fmt_pkzip.params.max_keys_per_crypt = n*256;
 #endif
-	// if not openmp and not use mult_tab, make sure we quiet the unused warning.
+	/* if not openmp and not use mult_tab, make sure we quiet the unused warning. */
 	(void)n;
+
+#if USE_PKZIP_MAGIC
+
+	//static char *MagicTypes[]= { "", "DOC", "XLS", "DOT", "XLT", "EXE", "DLL", "ZIP", "BMP", "DIB", "GIF", "PDF", "GZ", "TGZ", "BZ2", "TZ2", "FLV", "SWF", "MP3", NULL };
+	//static int  MagicToEnum[] = {0,  1,    1,     1,     1,     2,     2,     3,     4,     4,     5,     6,     7,    7,     8,     8,     9,     10,    11,  0};
+	// decent sources of these:
+	// http://www.garykessler.net/library/file_sigs.html
+	// http://en.wikipedia.org/wiki/List_of_file_signatures 
+	// http://toorcon.techpathways.com/uploads/headersig.txt
+	// there are many more.
+
+//case 1: // DOC/XLS
+	SIGS[1].magic_signature[0] = (u8*)str_alloc_copy("\xD0\xCF\x11\xE0\xA1\xB1\x1A\xE1");
+	SIGS[1].magic_sig_len[0] = 8;
+	SIGS[1].magic_signature[1] = buf_copy("\x50\x4B\x03\x04\x14\x00\x06\x00\x08", 10);  // a .zip file 'sort of'
+	SIGS[1].magic_sig_len[1] = 9;
+	SIGS[1].magic_signature[2] = buf_copy("\x09\x04\x06\x00\x00\x00\x10\x00\xF6\x05\x5C\x00", 13); // older XLS format (office 95)
+	SIGS[1].magic_sig_len[2] = 12;
+	SIGS[1].magic_signature[3] = buf_copy("\x09\x02\x06\x00\x00\x00\x10\x00\xB9\x04\x5C\x00", 13); // older XLS v2
+	SIGS[1].magic_sig_len[3] = 12;
+	SIGS[1].magic_signature[4] = buf_copy("\x50\x4B\x03\x04\x14\x00\x00\x00\x00\x00", 11); //DOC Star Writer 6.0 
+	SIGS[1].magic_sig_len[4] = 10;
+	SIGS[1].magic_signature[5] = buf_copy("\x31\xBE\x00\x00\x00\xAB\x00\x00", 9); //DOC MS Word for DOS v6 File 
+	SIGS[1].magic_sig_len[5] = 8;
+	SIGS[1].magic_signature[6] = (u8*)str_alloc_copy("\x12\x34\x56\x78\x90\xFF"); //DOC MS Word 6.0 File 
+	SIGS[1].magic_sig_len[6] = 6;
+	SIGS[1].magic_signature[7] = (u8*)str_alloc_copy("\x7F\xFE\x34\x0A");  //MS Word File
+	SIGS[1].magic_sig_len[7] = 4;
+	SIGS[1].magic_count = 8;
+	SIGS[1].max_len = 12;
+//case 2: // Win32/DOS exe file MZ
+	SIGS[2].magic_signature[0] = (u8*)str_alloc_copy("MZ");
+	SIGS[2].magic_sig_len[0] = 2;
+	SIGS[2].magic_count = 1;
+	SIGS[2].max_len = 2;
+//case 3: // PKZIP
+	SIGS[3].magic_signature[0] = (u8*)str_alloc_copy("\x50\x4B\x03\x04");
+	SIGS[3].magic_sig_len[0] = 4;
+	SIGS[3].magic_count = 1;
+	SIGS[3].max_len = 4;
+//case 4: // BMP
+	SIGS[4].magic_signature[0] = (u8*)str_alloc_copy("BM");
+	SIGS[4].magic_sig_len[0] = 2;
+	SIGS[4].magic_count = 1;
+	SIGS[4].max_len = 2;
+//case 5: // GIF
+	SIGS[5].magic_signature[0] = (u8*)str_alloc_copy("GIF87a");
+	SIGS[5].magic_sig_len[0] = 6;
+	SIGS[5].magic_signature[1] = (u8*)str_alloc_copy("GIF89a");
+	SIGS[5].magic_sig_len[1] = 6;
+	SIGS[5].magic_count = 2;
+	SIGS[5].max_len = 6;
+//case 6: // PDF
+	SIGS[6].magic_signature[0] = (u8*)str_alloc_copy("%PDF");
+	SIGS[6].magic_sig_len[0] = 4;
+	SIGS[6].magic_count = 1;
+	SIGS[6].max_len = 4;
+//case 7: // GZ
+	SIGS[7].magic_signature[0] = (u8*)str_alloc_copy("\x1F\x8B\x08");
+	SIGS[7].magic_sig_len[0] = 3;
+	SIGS[7].magic_count = 1;
+	SIGS[7].max_len = 3;
+//case 8: // BZ2  (there is a 'magic' pi, but byte 4 is 1 to 9, so skip the 'pi')
+	SIGS[8].magic_signature[0] = (u8*)str_alloc_copy("BZh");
+	SIGS[8].magic_sig_len[0] = 3;
+	SIGS[8].magic_signature[1] = (u8*)str_alloc_copy("BZ0");
+	SIGS[8].magic_sig_len[1] = 3;
+	SIGS[8].magic_count = 2;
+	SIGS[8].max_len = 3;
+//case 9: // FLV
+	SIGS[9].magic_signature[0] = (u8*)str_alloc_copy("FLV\x01");
+	SIGS[9].magic_sig_len[0] = 4;
+	SIGS[9].magic_count = 1;
+	SIGS[9].max_len = 4;
+//case 10: // SWF
+	SIGS[10].magic_signature[0] = (u8*)str_alloc_copy("FWS");
+	SIGS[10].magic_sig_len[0] = 5;
+	SIGS[10].magic_count = 1;
+	SIGS[10].max_len = 5;
+//case 11: // MP3
+	SIGS[11].magic_signature[0] = (u8*)str_alloc_copy("ID3");
+	SIGS[11].magic_sig_len[0] = 3;
+	SIGS[11].magic_count = 1;
+	SIGS[11].max_len = 3;
+
+	SIGS[255].max_len = 64;
+#endif
 }
 
 static void set_salt(void *_salt) {
 	salt = *((PKZ_SALT**)_salt);
 }
 
-static void load_bin_data(u8 *inp, u8 **out) {
-	int i, len = strlen((c8*)inp);
-	/* Needs word align on REQ_ALIGN systems */
-	*out = mem_alloc_tiny(len>>1, MEM_ALIGN_WORD);
-	for (i = 0; i < len>>1; ++i)
-		(*out)[i] = (atoi16[ARCH_INDEX(inp[i<<1])]<<4) + atoi16[ARCH_INDEX(inp[(i<<1)+1])];
-}
-
 static void *get_salt(char *ciphertext)
 {
 	/* NOTE, almost NO error checking at all in this function.  Proper error checking done in valid() */
 	static unsigned char salt_p[8];
 	PKZ_SALT *salt;
+	long offset=0;
+	u32 offex;
 	int i, j;
 	u8 *p, *cp, *cpalloc = (unsigned char*)mem_alloc(strlen(ciphertext)+1);
 
